﻿using System;
using System.Windows.Controls;
using System.Windows.Threading;

namespace TestProject
{
    /// <summary>
    /// 컨트롤 확장
    /// </summary>
    public static class ControlExtension
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Public

        #region 필요시 UI 스레드에서 호출하기 - InvokeOnUIThreadIfRequired(control, action)

        /// <summary>
        /// 필요시 UI 스레드에서 호출하기
        /// </summary>
        /// <param name="control">컨트롤</param>
        /// <param name="action">액션</param>
        public static void InvokeOnUIThreadIfRequired(this Control control, Action action)
        {
            if(!control.Dispatcher.CheckAccess())
            {
                control.Dispatcher.BeginInvoke
                (
                    DispatcherPriority.Normal,
                    new Action(delegate () { action(); })
                );
            }
            else
            {
                action.Invoke();
            }
        }

        #endregion
    }
}